(* ---------------------------------------------------------------

<***MODULE>actionTheory<***/MODULE>

<***DESC NAME="ROOT">
This module defines some notions on actions (transitions), such as the
notion of Hoare Triple specification.
<***/DESC>

<***AUTHOR> 
@@NAME Wishnu Prasetya
@@EMAIL wishnu@cs.uu.nl
@@EMAIL conjurerPrime@yahoo.com
@@URL www.cs.uu.nl/~wishnu
<***/AUTHOR>

<***VERSION>
@@DATE Feb 2002 on Hol2.00 Taupo 6
@@DATE Sept 2001
<***/VERSION>

<***DESC NAME="Hoare Triple">

Given an action a, we define:

<blockquote>
<pre>
HOA_def: |- !p a q. HOA p a q = !s t. p s /\ a s t ==> q t
</pre>
</blockquote>

This defines a partial notion of correctness. We usually use this in
the context where the actions can be assumed to be terminating.

<***/DESC>

--------------------------------------------------------------- *)
open Parse HolKernel basicHol90Lib 

infix THEN THENL THENC ORELSE ORELSEC THEN_TCL ORELSE_TCL ## |-> 

infixr --> 
  
val _ = new_theory "action"

val HOA_def
	=
	new_definition ("HOA_def",
	--`HOA p a q = !s t. p s /\ a s t ==> q t`--		) ;

(* 
NOTE: I decide to remove attempt to add syntactical sugaring like
this, as I repeatedly got crashed by conflicting tokens/priority
etc... Very annoying. Until HOL puts a more robust syntax
customization support, I think I'd better not waste time into doing
things like this.


val _ = add_rule 
	{ term_name 	= "HOA",
	  fixity 	= TruePrefix 520,
	  pp_elements	= [PPBlock ([TOK "PRE", BreakSpace(1,2), TM, 
				     BreakSpace(1,0), 
				     TOK "ACTION"], 
				     (PP.CONSISTENT, 3)),
			   BreakSpace(1,2), TM,  BreakSpace(1,0),
			   BeginFinalBlock(PP.CONSISTENT,2),
			   TOK "POST",  BreakSpace(1,0)],
	  paren_style	= OnlyIfNecessary,
	  block_style	= (AroundEachPhrase, (PP.INCONSISTENT,0))
	} ;
*)

val _ = export_theory() ;
